using UnityEngine; //livraria unity

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            CategoryBuilder.Create("GTASA", "GTASA", ModAPI.LoadSprite("Category.png"));
            
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Carl Jonhson +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "CJ From GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/CJ/CJThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/CJ/CJ.png");
                        var bone = ModAPI.LoadTexture("People/BoneLayer.png");
                        var flesh = ModAPI.LoadTexture("People/FleshLayer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(86, 62, 130); //Hematoma 1
                        person.SetSecondBruiseColor(154, 0, 7); //Hematoma 2
                        person.SetThirdBruiseColor(207, 206, 120); //Hematoma 3
                        person.SetRottenColour(202, 199, 104); //Podre
                        person.SetBloodColour(100, 24, 26); //Sangue
                    }

                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sweet Jonhson +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "brother of carl jonhson, sweet is a member of the fabulous grove street families from GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Sweet/SweetThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Sweet/Sweet.png");
                        var bone = ModAPI.LoadTexture("People/BoneLayer.png");
                        var flesh = ModAPI.LoadTexture("People/FleshLayer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(86, 62, 130); //Hematoma 1
                        person.SetSecondBruiseColor(154, 0, 7); //Hematoma 2
                        person.SetThirdBruiseColor(207, 206, 120); //Hematoma 3
                        person.SetRottenColour(202, 199, 104); //Podre
                        person.SetBloodColour(100, 24, 26); //Sangue
                    }

                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vagos 1 +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Gangster of Los Santos Vagos of GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Vagos1/Vagos1Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Vagos1/Vagos1.png");
                        var bone = ModAPI.LoadTexture("People/BoneLayer.png");
                        var flesh = ModAPI.LoadTexture("People/FleshLayer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(86, 62, 130); //Hematoma 1
                        person.SetSecondBruiseColor(154, 0, 7); //Hematoma 2
                        person.SetThirdBruiseColor(207, 206, 120); //Hematoma 3
                        person.SetRottenColour(202, 199, 104); //Podre
                        person.SetBloodColour(100, 24, 26); //Sangue
                    }

                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Ballas 1 +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Gangster of Ballas of GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Ballas1/Ballas1Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Ballas1/Ballas1.png");
                        var bone = ModAPI.LoadTexture("People/BoneLayer.png");
                        var flesh = ModAPI.LoadTexture("People/FleshLayer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(86, 62, 130); //Hematoma 1
                        person.SetSecondBruiseColor(154, 0, 7); //Hematoma 2
                        person.SetThirdBruiseColor(207, 206, 120); //Hematoma 3
                        person.SetRottenColour(202, 199, 104); //Podre
                        person.SetBloodColour(100, 24, 26); //Sangue
                    }

                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Colt 45 +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "From GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("Weapons/pistol/PistolThumb.png"),
                    AfterSpawn = (Instance) =>
                    {                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/Pistol/pistol.png", 1.5f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "Extremely Regular Bullet";
                        customCartridge.Damage *= 5f;
                        customCartridge.StartSpeed *= 0.5f;
                        customCartridge.Recoil *= 0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.25f;
                        customCartridge.ImpactForce *= 0f;

                        firearm.Cartridge = customCartridge;

                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Weapons/Pistol/pistol.mp3")

                        };
                    }
                
                }
            
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "Micro Uzi +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "From GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("Weapons/Micro_SMG/msmgThumb.png"),
                    AfterSpawn = (Instance) =>
                    {                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/Micro_SMG/msmg.png", 2.0f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "Extremely Regular Bullet";
                        customCartridge.Damage *= 4f;
                        customCartridge.StartSpeed *= 0.5f;
                        customCartridge.Recoil *= 0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.25f;
                        customCartridge.ImpactForce *= 0f;

                        firearm.Cartridge = customCartridge;

                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Weapons/Micro_SMG/msmg.mp3")

                        }
                        ;
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                    }
                
                }
            
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "AK47 +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "From GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("Weapons/Ak_47/ak47Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/Ak_47/ak47.png", 1.5f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("30 mm");
                        customCartridge.name = "Extremely Regular Bullet";
                        customCartridge.Damage *= 5.5f;
                        customCartridge.StartSpeed *= 0.5f;
                        customCartridge.Recoil *= 0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.25f;
                        customCartridge.ImpactForce *= 0f;

                        firearm.Cartridge = customCartridge;

                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Weapons/Ak_47/ak47.mp3")

                        };
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;
                        
                    }
                
                }
            
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),
                    NameOverride = "Baseball Bat +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "From GTA:SA",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("Weapons/Bat/BatThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/Bat/Bat.png");
                    }
                }
            );
            
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Cap +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Cap of Grove Stree Families.",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("Clothes/cap.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Clothes/cap.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Bandana +SA",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Bandana of Grove Stree Families.",
                    CategoryOverride = ModAPI.FindCategory("GTASA"),
                    ThumbnailOverride = ModAPI.LoadSprite("Clothes/bandana.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Clothes/bandana.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                    }
                }
            );
            
        }
    }
}